#!/bin/bash
#
# Wrapper-script for DailyMerge.mak.
#
# $Id: dailyMerge.sh,v 1.1.4.4 2011/12/02 11:50:55 ttester Exp $


if [ ! -r /etc/default/epages6 ] ; then
     echo 'No ePages installation found.'
     exit 1
else
     . /etc/default/epages6
fi

# Remove left-overs from previous runs.
if [ -d "$EPAGES_CARTRIDGES/DE_EPAGES/CodeGenerator/Scripts/RND" ] ; then
     rm -Rf $EPAGES_CARTRIDGES/DE_EPAGES/CodeGenerator/Scripts/RND
fi

# Call DailyMerge.mak which handles everything else.
TIMESTAMP="`date +%y%m%d-%H%M`"
if [ -d "$EPAGES_CARTRIDGES/DE_EPAGES/CodeGenerator/Scripts" ] ; then
     cd $EPAGES_CARTRIDGES/DE_EPAGES/CodeGenerator/Scripts
     make -f dailyMerge.mak PERL=$PERL 2>&1 | tee "$EPAGES_LOG/merge-${TIMESTAMP}.txt"
     # "merge-111116-1628.txt"
     # nmake -nologo -f DailyMerge.mak 2>&1 | tee "%EPAGES_LOG%\merge-%DATE:~8,8%%DATE:~3,2%%DATE:~0,2%-%TIME:~0,2%%TIME:~3,2%.txt"
     if [[ ${PIPESTATUS[0]} -ne 0 ]] ; then
          exit 1
     fi
else
     echo "Directory $EPAGES_CARTRIDGES/DE_EPAGES/CodeGenerator/Scripts does not exist."
     exit 1
fi

# Save artifact, if $WORKSPACE exists.
if [ -d "$WORKSPACE" ] ; then
     [ -r "$EPAGES_LOG/merge-${TIMESTAMP}.txt" ] && cp -v "$EPAGES_LOG/merge-${TIMESTAMP}.txt" "$WORKSPACE"/.
else
     echo 'Variable $WORKSPACE is not defined.'
fi

# Remove working directory RND.
if [ -d "$EPAGES_CARTRIDGES/DE_EPAGES/CodeGenerator/Scripts/RND" ] ; then
     rm -Rf $EPAGES_CARTRIDGES/DE_EPAGES/CodeGenerator/Scripts/RND
fi
