/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.inc.sf-initialize
 *
 * @revision		$Revision: 1.4.20.1 $
 */

jQuery.plugin( 'de_epages.design.inc.sf-initialize', function( $, undefined ){

	var win = $(window),
		// Regexp to find anchor jump mark
		anchorExp = /#([\w][\w\d]*)$/,
		// jump to position handle
		scrollFix = function( event, href ){
			var match = anchorExp.exec( href || $(this).attr('href') );
			if( match ){
				var refElem = $('#'+match[1]+', a[name="'+match[1]+'"]');
				if( refElem.length ){
					win.scrollTop( refElem.offset().top );
					event.preventDefault();
				}
			}
		};

	// handle jump to id on a site
	$(document).on( 'click', 'a', scrollFix );

	if( anchorExp.test(location.href) ){
			// fix anchor jump on page load
		var startUpFix = function(){
				clearInterval(intervalId);

				middle.scrollTop(0);

				scrollFix( $.Event(), location.href );
			},
			// check anchor jump on page load
			intervalCall = function(){
				intervalIndex++;
				if( intervalIndex >= 25 || middleChild.position().top < 0 ){
					startUpFix();
				}
			},
			// check count
			intervalIndex = 0,
			// check id
			intervalId,
			// container to fix
			middle,
			// first child of container
			middleChild;

		$.ready(function(){
			middle = $('.Middle').on('scroll',startUpFix);
			middleChild = middle.children(':first');
			// start check handle
			intervalId = setInterval(intervalCall,100);
		});
	}

});