
dojo.provide('epages.cartridges.de_epages.externalcontent.fblike');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.fblike = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.fblike,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.fblike',
	title           : 'Facebook Like-Button',

	fb_layout				: 'standard',
	fb_show_faces		: ["yes",""],
	fb_action				: 'like',


	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_fb-like.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			fb_layout				: this.fb_layout,
			fb_show_faces	  : this.fb_show_faces,
			fb_action				: this.fb_action
		});
		return info;
	},

	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}

		if(this.formData.get("fb_layout")[0] == 'button_count') {
			this.fb_layout = 'button_count';
		} else if(this.formData.get("fb_layout")[0] == 'box_count') {
			this.fb_layout = 'box_count';
		}
		else{
			this.fb_layout = 'standard';
		}

		if(this.formData.get('fb_show_faces')[0] == 'true'){
			this.fb_show_faces = 'true';
		}
		else{
			this.fb_show_faces = 'false';
		}

		if(this.formData.get('fb_action') == 'recommend'){
			this.fb_action = 'recommend';
		}
		else{
			this.fb_action = 'like';
		}

	},

	contentString: function (info, ispreview) {
		var retString;
		var tmpWidth;
		var tmpHeight;
		var timestamp = (new Date()).getTime();

		var tmp = this.fb_show_faces[0] == "true" ? "true" : "false";
		if( this.formData.get("fb_layout")[0] == "button_count" ) {
			tmpWidth = '90';
		} else if( this.formData.get("fb_layout")[0] == "box_count" ) {
			tmpWidth = '85';
		} else {
			tmpWidth = '225';
		}
		if( this.formData.get("fb_layout")[0] == "button_count" ) {
			tmpHeight = '21';
		} else if( this.formData.get("fb_layout")[0] == "box_count" ) {
			tmpHeight = '65';
		} else {
			tmpHeight = '80';
		}
		
		//variant for preview - inside the preview iframe we don't have jquery so we have to use the old syntax
		if(ispreview){
			var href = epages.vars.CanonicalURL ? epages.vars.CanonicalURL : epages.vars.WebUrl;
			href = encodeURIComponent(href);

			retString = '<iframe src="' + location.protocol+ '//www.facebook.com/plugins/like.php?href=' + href + '&layout=' + this.fb_layout + '&show_faces=' + tmp + '&width=' + tmpWidth;
			retString += 'auto&action=' + this.fb_action + '&colorscheme=light&height=' + tmpHeight;
			retString += '" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:' + tmpWidth;
			retString += 'px; height:'+ tmpHeight +'px;" allowTransparency="true"></iframe>';
		}
		//life code
		else{
			var href = "location.protocol + '//www.facebook.com/plugins/like.php?href=' + encodeURIComponent((ep.config.canonicalUrl ? ep.config.canonicalUrl : ep.config.webUrl)) + '&layout=" + this.fb_layout + "&show_faces=" + this.fb_show_faces + "&width=" + tmpWidth + "&action=" + this.fb_action + "&colorscheme=light&height=" + tmpHeight + "'";

			retString = '<iframe id="fb_like_iframe_'+ timestamp +'" scrolling="no" frameborder="0" allowtransparency="true" style="border:none; overflow:hidden;" src="about:blank"></iframe>\n';
			retString += '<script type="text/javascript">\n';
			retString += 'jQuery.ready(function($){\n';
			retString += 'var iframeNode = $(\'#fb_like_iframe_'+ timestamp +'\');\n';
			retString += 'var facebookUrl = ' + href + ';\n';
			retString += 'iframeNode.attr(\'src\',facebookUrl);\n';
			retString += 'iframeNode.css({width: \''+ tmpWidth +'px\',height: \''+ tmpHeight +'px\'});\n';
			retString += '});\n';
			retString += '</script>\n';
		}

		return retString;
	}
});