
dojo.provide('epages.cartridges.de_epages.externalcontent.googleplus');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.googleplus = epages.Class();

dojo.extend( epages.cartridges.de_epages.externalcontent.googleplus, epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.googleplus',
	title           : 'Google +1 Button',

	googleplus		: {
		size:			'',
		counter		:	1
	},

	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_googleplus.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);

		dojo.mixin(info, this.googleplus);

		return info;
	},

	saveForm: function() {
		if( this.form !== undefined ){
			this.formData = (new epages.html.Form(this.form)).get();
		}

		this.googleplus.size	= this.formData.get("googleplus_size")[0] || '';
		this.googleplus.counter = this.formData.get("googleplus_counter")[0]==1 ? 1 : 0;
	},

	contentString: function( info, ispreview ){
		var retString = '',
			tmpWidth,
			tmpHeight,
			timestamp = (new Date()).getTime();

		if( ispreview ){
			retString +=
				'<g:plusone' +
					(info.size ? ' size="'+info.size+'"' : '') +
					(!info.counter	? ' data-annotation:"none",' : '') +
				'></g:plusone>\n' +
				'<script type="text/javascript">\n' +
				'  (function(){\n' +
				'    var po = document.createElement("script");\n' +
				'    po.type = "text/javascript";\n' +
				'    po.async = true;\n' +
				'    po.src = "https://apis.google.com/js/plusone.js";\n' +
				'    var s = document.getElementsByTagName("script")[0];\n' +
				'    s.parentNode.insertBefore(po, s);\n' +
				'  })();\n' +
				'</script>\n' +
				'';
		}
		else{
			retString +=
				'<div class="g-plusone" id="gadget_plusone_'+timestamp+'"></div>\n' +
				'<script type="text/javascript">\n' +
				'  jQuery.ready( {plugin:"ep.core",DOM:true}, function($){\n' +
				'    $("#gadget_plusone_'+timestamp+'")\n' +
				'      .attr({\n' +
						(info.size		? ' "data-size":"'+info.size+'",' : '') +
						((info.counter==0)	? ' "data-annotation":"none",' : '') +
				'        href: ep.config.canonicalUrl || ep.config.webUrl\n' +
				'       });\n' +
				'    window.___gcfg = {lang: ep.config.language};\n' +
				'    var po = document.createElement("script");\n' +
				'    po.type = "text/javascript";\n' +
				'    po.async = true;\n' +
				'    po.src = "https://apis.google.com/js/plusone.js";\n' +
				'    var s = document.getElementsByTagName("script")[0];\n' +
				'    s.parentNode.insertBefore(po, s);\n' +
				'  });\n' +
				'</script>\n' +
				'';
		}
		
		return retString;
	}
});