/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ajax
 *
 * @revision		$Revision: 1.9.8.1.2.2 $
 */

jQuery.plugin( 'ep.ajax', 'ep.core', function( $, undefined ){

	ep.extend({
		ajax: function( settings ){

			var jqXHR;

			if( !settings.url ){
				settings.url = ep.config.baseUrl;
			}

			if( settings.dataType === 'json' ){
				var _beforeSend = settings.beforeSend;

				$.extend(settings,{
					beforeSend: function( xhr, s ){
						xhr.setRequestHeader("Accept", "application/json");
						if( _beforeSend ){
							_beforeSend( xhr, s );
						}
					}
				});

				var maps		= {},
					originals	= {},
					stacks		= {
						done		: settings.success	? [settings.success]	: [],
						fail		: settings.error	? [settings.error]		: [],
						always		: settings.complete	? [settings.complete]	: []
					};

				settings.success = settings.error = settings.complete = undefined;
				jqXHR = $.ajax(settings);
				jqXHR.success = jqXHR.error = jqXHR.complete = undefined;

				$.each(['done', 'fail', 'always'], function(i, name){
					var finished = [];
					originals[ name ] = jqXHR[ name ];

					jqXHR[ name ]	= function(fn){
						stacks[ name ].push(fn);
						if( finished.length && (name != 'done' || finished[2]=='success') ){
							fn.call( finished[0], finished[1], finished[2], finished[3] );
						}
						return this;
					};

					originals[ name ](function( data, status, xhr ){
						var self = this,
							type = name;

						if( status == 'success' && data && data.Errors ){
							var temp = xhr;
							xhr = data.Errors;
							data = temp;
							data.status = 400;
							data.statusText = status = "error";
							if( type == 'done' ){
								type = 'fail';
							}
						}

						finished = [self, data, status, xhr];

						$.each(stacks[ type ], function(i, fn){
							fn.call( self, data, status, xhr);
						});
					});

				});
			}
			else{
				jqXHR = $.ajax(settings);
			}

			return jqXHR;
		}
	});

});
