/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.fn.holdOnTop
 *
 * @revision		$Revision: 1.1.4.2 $
 */

jQuery.plugin( 'ep.fn.holdOnTop', 'ep.core', function( $, undefined ){

	var win = $(window),

		elementStack = [],

		holdOnTop = function( i ){
			var self			= this,
				o				= self.options,
				elem			= self.element,
				body			= $('body'),
				parent			= elem
					.offsetParent(),
				placeholder		= (self.placeholder || (self.placeholder = $('<div>').insertBefore( elem )) )
					.hide(),
				elemPos			= elem
					.css('position','relative')
					.css(self.restore)
					.offset(),
				parentPos		= parent
					.offset(),
				bodyPos			= { top:window.pageYOffset, left:window.pageXOffset },
				setCSS			= { position: 'absolute' };


			if( o == 'bottom' ){
				var bodyHeight = body.outerHeight(true);

				elemPos.bottom		= bodyHeight - elem.outerHeight(true) - elemPos.top;
				parentPos.bottom	= bodyHeight - parent.outerHeight(true) - parentPos.top;
				bodyPos.bottom		= bodyHeight - win.height() - bodyPos.top;
			}
			else if( o == 'right' ){
				var bodyWidth = body.outerWidth(true);

				elemPos.right		= bodyWidth - elem.outerWidth(true) - elemPos.left;
				parentPos.right		= bodyWidth - parent.outerWidth(true) - parentPos.left;
				bodyPos.right		= bodyWidth - win.width() - bodyPos.left;

			}

			if( bodyPos[ o ] > elemPos[ o ] ){
				setCSS[ o ] = (bodyPos[ o ]-parentPos[ o ]) + 'px';
				self.placeholder
					.width( elem.outerWidth(true) )
					.height( elem.outerHeight(true) )
					.show();
				elem.css(setCSS)
					.addClass('holdOnTop');
			}
			else if( bodyPos[ o ] < elemPos[ o ] ){
				elem.removeClass('holdOnTop');
			}
		},

		onEvent = function(){
			$.each( elementStack, holdOnTop )
		};

	ep.fn.holdOnTop = function( options ){
		return this.each(function(){
			elementStack.push({
				element:	$(this),
				options:	options || 'top',
				restore:	{
					top:		$.style(this, 'top'),
					right:		$.style(this, 'right'),
					bottom:		$.style(this, 'bottom'),
					left:		$.style(this, 'left'),
					width:		$.style(this, 'width'),
					height:		$.style(this, 'height')
				}
			});
		});
	};

	win.on( 'scroll resize', onEvent );
});