/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.sslSwitch
 *
 * @revision		$Revision: 1.6.2.1 $
 */

jQuery.plugin( 'ep.sslSwitch', 'ep.core', function( $, undefined ){

    ep.sslSwitch = {
        handles: [],

        controller: function( event ){
 			var elem = $(this),
                form = elem.filter('form');

            if( !form.length ){
                form = $('<form method="post" action="'+elem.attr('href')+'"/>').appendTo('body');
            }

            $.each( ep.sslSwitch.handles, function( i, handle ){
                handle( event, form );
            });
			
			if( !event.isDefaultPrevented() ){
				event.preventDefault();
            	ep.sslSwitch['submit']( form, true );
            }
        },

        addHandle: function( fn ){
            ep.sslSwitch.handles.push( fn );
        },

        submit: function( form ){
 			if( arguments[1] ){
            	form[0].submit();
 			}
 			else{
 				form.trigger('submit');
            }
        }
    };

	$(document)
		.on( 'click',	'a.SSLSwitch',		ep.sslSwitch.controller )
		.on( 'submit',	'form.SSLSwitch',	ep.sslSwitch.controller );

});