/*
 * @copyright		© Copyright 2006-2011, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ui.contentBox
 *
 * @revision		$Revision: 1.1.4.3 $
 */
jQuery.plugin( 'ep.ui.contentbox', ['ep.core', 'jQuery.ui.widget'], function($){

	$.widget( 'ep.ui.contentboxList', {
		options: {
		//	beforeToggle: function(){},
		//	afterToggle: function(){},
			cols: 1
		},
		_create: function(){
			var self = this,
				o = this.options;

			self.elem = self.element
				.sub(ep)
				.addClass('ep-contentBox-listCol'+o.cols);

			self.items = self.elem
				.children('li');

			self.boxes = self.items
				.children('label');

			if( self.boxes.length )	{
				self.useLabel = true;
			}
			else{
				self.useLabel = false;
				self.boxes = self.items
					.children('div')
					.on( 'click', function(){
						var input = $(this)
							.children('input');

						if( !input.is(':checked') ){
							input.prop('checked',true)
								.trigger('change');
						}
					});
			}

			self.boxes
				.addClass('ep-contentBox-check');

			self.boxesCheck = self.boxes
				.children('input')
				.on('change',self.Proxy('_change'));
		},
		_init: function(){
			this._change( true );
		},
		_change: function( event ){
			var self = this,
				o = this.options;

			self.boxesCheck
				.each(function(){
					var elem = $(this),
						checked = elem.is(':checked');

					if( o.beforeToggle ){
						o.beforeToggle.call( elem, self, checked );
					}

					elem.next()
						.find('.ep-contentBox-shonOnCheck')
						.toggleClass('HideElementSoft',!checked)
						.find(":input")
						.attr("disabled", !checked);

					if( o.afterToggle ){
						o.afterToggle.call( elem, self, checked );
					}
				});

			if( event!==true ){
				self.element.trigger('changeList');
			}
		}
	});
});