/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ui.coverflow
 *
 * @revision		$Revision: 1.12.2.2 $
 */

jQuery.plugin( 'ep.ui.coverflow', ['ep.core', 'jQuery.ui.widget', 'jQuery.support.flash', 'jQuery.compareVersion'], function( $, undefined ){

	$.widget('ep.ui.Coverflow',{
		imageData: null,
		titleText: null,
		id: null,
		coverflowModuleSrc: location.protocol + '//' + location.host + ep.config.javascriptRoot + '/ep/ui/Coverflow.swf',
		options: {
			imagesData: null
		},

		_create: function(){
			this.Inherited(arguments);
			this.id = 'ep_ui_Coverflow_' + idCount++;
			this.imageData = [];
			idStack[this.id] = this.element;
			this.titleText = this.element.attr('title');
			var self = this;
			var imgId = 1;
			if(this.options.imagesData){
				var imagesData = this.options.imagesData;
				for(var i = 0, iLength = imagesData.length; i<iLength; i++){
					var imageData = imagesData[i];
					this.imageData.push([
					imageData.medium,
					ep.scrunch(imageData.description,40),
					imageData.href,
					null,
					false,
					i
					]);
				}
			}
			else{
				var imgNodes = this.element.find("a").each(function(index,elm){
					var elm = $(elm);
					var imgNode = elm.find('img:first');
					self.imageData.push([
						imgNode.attr('src'),
						imgNode.data('longdesc'),
						elm.attr('href'),
						elm.attr('href2'),
						(imgNode.attr("ismap") ? true : false),
						imgId
					]);
					imgId++;
				});
			}
			if( $.compareVersion($.support.flash,'9') >= 0) {
				if(this.imageData.length > 2){
					this.element.removeClass('HideElement');
					this._buildCoverflow();
					this.element.addClass('Flashed');
					$(window).on('resize',$.proxy(this,'_buildCoverflow'));
				}
				else{
					this._createFlashFallback();
					$('.ImageSlide').removeClass('HideElement');
					this.element.css({
						'text-align' : 'center',
						'overflow': 'hidden'
					});
					
					// check all a tags
					this.element.children('a').each(function(){
						var $this = $(this),
							$cloneImg = $this.children('img').clone('true');
						$this.empty();
						$this.append($cloneImg);
						// scale height if doesn't fit into coverflow element
						if($cloneImg.height() > self.element.height()){
							$cloneImg.height(self.element.height());
						}
					});
				}
			}
			else{
				this._createFlashFallback();
				$('.ImageSlide, .ImageGalleryListItemContainer').removeClass('HideElement');
			}
		},

		_createFlashFallback: function(){
			if(this.element.children().length == 0){
			var self = this;
				$.each(this.imageData,function(index,value){
					var aNode = $('<a>')
						.attr('href',value[2])
						.appendTo(self.element);
					$('<img>')
						.attr('src',value[0])
						.appendTo(aNode);
				});
			}
			this.element.removeClass('HideElement');
		},

		getData: function(){
			return this.imageData;
		},

		addToBasket: function(){
			var currentImageId = $('#'+this.id+'_flash').attr('currentimageid');
			if(currentImageId == ''){
				var found = (/currentimageid=["'](\d+)["']/).exec( $('#'+this.id+'_flash').parent().html() );
				currentImageId = found ? found[1] : '';
			}
			for(var i = 0, iLength = this.imageData.length; i < iLength; i++){
				currentImageData = this.imageData[i];
				if(currentImageId == currentImageData[5] && ep.config.baseUrl && currentImageData[3]){
					var addToBasketLink = ep.config.baseUrl + currentImageData[3];
					//we need to call the addToBasket by AJAX so that the IE is sending a Referer
					$.ajax({
						type: 'GET',
						url: addToBasketLink,
						async: false,
						success: function(){
							if(location.protocol.toLowerCase() == "https:"){
								window.location.href = epConfig.webUrlSsl;
							}
							else{
								window.location.href = epConfig.webUrl;
							}
						}
					});

				}
			}
		},

		_buildCoverflow: function() {
			this.element.attr('title',this.titleText);
			if($.browser.msie && parseInt($.browser.version) <= 8){
				//random string is necessary to avoid that the IE thinks he had not to render the flash again
				swfSrc = this.coverflowModuleSrc + "?" + String(Math.floor(Math.random()*9999));
			}
			else{
				swfSrc = this.coverflowModuleSrc;
			}
			var coverflowString = '<object name="'+this.id+'_flash" id="'+this.id+'_flash" callback="ep(ep.ui.Coverflow.getWidget(\'' + this.id + '\')).uiCoverflow(\'getData\');"  addtobasket="ep(ep.ui.Coverflow.getWidget(\'' + this.id + '\')).uiCoverflow(\'addToBasket\');" currentimageid="" type="application/x-shockwave-flash" data="' + swfSrc + '" > <param name="movie" value="' + swfSrc + '" /> <param name="allowscriptaccess" value="always" /> <param name="wmode" value="transparent" /></object>';
			this.element.html(coverflowString);
		},

		destroy: function(){
			this.Inherited(arguments);
		}

	});
	var idStack = {};
	var idCount = 1;
	$.extend(ep.ui.Coverflow, {
		getWidget: function(coverflowID){
			return idStack[coverflowID];
		}
	});

});