/*
 * @author			Emanuel Vitzthum
 * @copyright		© 2011 jQuery SDK v1.1.1
 * @info			http://www.jquerysdk.com
 *
 * @license			Dual licensed under the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL (http://www.gnu.org/licenses/gpl.html)
 *
 * @plugin			jQuery.fn.size
 */

jQuery.plugin( 'jQuery.fn.size', function( $, undefined ){

	// support set method for: inner / outer => width / height
	$.each([ 'Height', 'Width' ], function( i, Name ) {
		var name = Name.toLowerCase();

		$.fn[ 'inner' + Name ] = function( val ){
			return $.type(val)==='number' ?
				this.each(function(){
					$.style( this, name, val - ( parseFloat( $.css( this, name, 'padding' ) ) - parseFloat( $.css( this, name ) ) ) );
				}) :
				this[0] ?
					parseFloat( $.css( this[0], name, 'padding' ) ) :
					null;
		};
		$.fn[ 'outer' + Name ] = function( val, margin ){
			return $.type(val)==='number' ?
				this.each(function(){
					$.style( this, name, val - ( parseFloat( $.css( this, name, margin ? 'margin' : 'border' ) ) - parseFloat( $.css( this, name ) ) ) );
				}) :
				this[0] ?
					parseFloat( $.css( this[0], name, val ? 'margin' : 'border' ) ) :
					null;
		};
	});

});