/*
 * @author			Emanuel Vitzthum
 * @copyright		© 2011 jQuery SDK v1.1.1
 * @info			http://www.jquerysdk.com
 *
 * @license			Dual licensed under the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL (http://www.gnu.org/licenses/gpl.html)
 *
 * @plugin			jQuery.metaparse
 */

jQuery.plugin( 'jQuery.metaparse', function( $, undefined ){

	var metaparse = function( data ){
			var ret = '';

			data = data.replace( /([^\s]+\(.*\))/, function( m, m1 ){
				ret = m1;
				return '';
			});

			return [data,ret];
		};

	$.extend({
		metaparse: function( elem, settings ){
			var s = settings ? $.extend( {}, $.metaparseSettings, settings ) : $.metaparseSettings,
				meta = ['',''],
				temp;

			if( s.type === "class" ){
				meta = metaparse(elem.className);
				elem.className = meta[0];
			}
			else if( s.type === "elem" ){
				if( !elem.getElementsByTagName )
					return;

				if( temp = elem.getElementsByTagName(s.name)[0] ){
					meta = metaparse(temp.innerHTML);
					temp.innerHTML = meta[0];
				}
			}
			else if( elem.getAttribute != undefined ){
				if( s.type==='html5' )
					s.name = 'data-'+s.name;

				if( temp = elem.getAttribute(s.name) ){
					meta = metaparse(temp);
					elem.setAttribute(s.name,meta[0]);
				}
			}

			if( meta[1] ){
				var data = (meta[1]).match(/([^\.\(]*)(.*)/);

				// $.globalEval isn't faster then eval this short string
				eval( (data[1] || "$") + "(elem)" + data[2] );
			}
		},
		metaparseSettings: $.extend(
			{
				type: 'class',
				name: 'metaparse'
			},
			$.config.metaparse
		)
	});

	$.fn.extend({
		metaparse: function( settings ){
			return this.each(function(){
					$.metaparse( this, settings );
				});
		}
	});

});