/*
 * @author			Emanuel Vitzthum
 * @copyright		© 2011 jQuery SDK v1.1.1
 * @info			http://www.jquerysdk.com
 *
 * @license			Dual licensed under the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL (http://www.gnu.org/licenses/gpl.html)
 *
 * @plugin			jQuery.scope
 */

jQuery.plugin( 'jQuery.scope', function( $, undefined ){

	$.extend({
		scope: function( scope, context ) {
			context = context || window;

			var parts = scope ? scope.split(/\./) : [];

			for( var i=0,l=parts.length ; i<l ; i++ ){
				context = context[parts[i]] || (context[parts[i]] = {});
			}

			return context;
		}
	});

});