#-*- Makefile -*-
require DE_EPAGES::Core::API::Makefile;
__DATA__
#
#   makefile
#
#   Project     :   epages 5
#   Copyright   :   ePages GmbH 2006
#   Version     :   Wed April 19 14:01:00 2006
#

!OS_SPECIFIC_DEFINES
!ifndef WINDOWS
MAKE		= PATH=$(EPAGES_PERL)/bin:$(PATH) make
!endif
COMPANY     = DE_EPAGES
CARTRIDGE   = ShopTransferProvider
MODELS      = 
CVS_BRANCH  = main
STORE       =
RECURSIVE   =
EPAGES_PASSWORD = $(PASSWORD)
EPAGES_TESTSITE = $(STORE)

CVS_CARTRIDGESPATH =RND/epages/epages5/AllOS/Cartridges
CVS_PATH        = $(CVS_CARTRIDGESPATH)/$(COMPANY)/$(CARTRIDGE)
DE_EPAGES   = ../../DE_EPAGES
CARTRIDGES  = $(COMPANY)::$(CARTRIDGE)
COMPANY_CARTRIDGE = COMPANY=$(COMPANY) CARTRIDGE=$(CARTRIDGE) DE_EPAGES="$(DE_EPAGES)"
PRGS = PERL="$(PERL)" MKDIR="$(MKDIR)" RMDIR="$(RMDIR)"

MAKE_GENERATE   = $(MAKE) -f $(DE_EPAGES)/CodeGenerator/Scripts/CodeGenerator.mak $(COMPANY_CARTRIDGE) MODELS=$(MODELS) CVS_BRANCH=$(CVS_BRANCH) CVS_PATH=$(CVS_PATH) $(PRGS)
MAKE_CORE   = $(MAKE) -f $(DE_EPAGES)/Core/Scripts/Core.mak $(COMPANY_CARTRIDGE) $(PRGS)
MAKE_DOC    = $(MAKE) -f $(DE_EPAGES)/SourceDoc/Scripts/SourceDoc.mak $(COMPANY_CARTRIDGE) $(PRGS)
MAKE_INSTALL    = $(MAKE) -f $(DE_EPAGES)/Installer/Scripts/Installer.mak STORE=$(STORE) CARTRIDGES=$(CARTRIDGES) DE_EPAGES="$(DE_EPAGES)" OLDRELEASE=$(OLDRELEASE) NEWRELEASE=$(NEWRELEASE) CVS_CARTRIDGESPATH=$(CVS_CARTRIDGESPATH) $(PRGS) RECURSIVE=$(RECURSIVE)
MAKE_REGISTER   = $(MAKE) -f $(DE_EPAGES)/ShopConfiguration/Scripts/Register.mak CARTRIDGES=$(CARTRIDGES) DE_EPAGES="$(DE_EPAGES)" $(PRGS)

makefile: Makefile.PL
	$(PERL) Makefile.PL
	$(PERL) -e "print \"Please restart '$(MAKE)' again makefile was updated.\n\";exit 1;"

clean: makefile
	-$(DEL) .*#* *.pdb
	-$(DEL) makefile
	-$(RMDIR) Generated

generate generate_merge generate_update: makefile
	$(MAKE_GENERATE) $@

install uninstall create_patch test_patch patch cpan: makefile
	$(MAKE_INSTALL) $@

register unregister: makefile
	$(MAKE_REGISTER) $@

sourcedoc: makefile
	$(MAKE_DOC) sourcedoc

test: makefile
	$(MAKE_CORE) test

export: makefile
	$(PERL) Scripts\bcp.pl      -storename $(STORE) -out
	$(PERL) Scripts\cleanUp.pl  -storename $(STORE)
	$(PERL) Scripts\export.pl   -storename $(STORE) -all

import: makefile
	$(PERL) Scripts\import.pl   -storename $(STORE) -system -all
	$(PERL) Scripts\cleanUp.pl  -storename $(STORE)
	$(PERL) Scripts\bcp.pl      -storename $(STORE) -out

export_import: makefile
	$(MOVE) "./out/$(SOURCE)/export" "./out/$(SOURCE)/import"
	$(MOVE) "./out/$(SOURCE)" "./out/$(TARGET)"
	$(MAKE) import STORE=$(TARGET)

transfer: makefile
	$(MAKE) verify EPAGES_TESTSITE=$(TARGET)
	$(MAKE) verify EPAGES_TESTSITE=$(SOURCE)
	$(PERL) Scripts\export.pl -storename $(TARGET) -system
	$(PERL) Scripts\export.pl -storename $(SOURCE) -all
	-$(RMDIR) out\$(SOURCE)\export\PreCreated*
	$(PERL) Scripts\transform.pl -storename $(TARGET) -source $(SOURCE) -all
	$(PERL) Scripts\import.pl   -storename $(TARGET) -all
	$(MAKE) verify EPAGES_TESTSITE=$(TARGET)

verify: makefile
	$(PERL) t\verifyReferences.t

sort: makefile
	sort $(SOURCE)/$(TABLE).bcp >$(SOURCE)/$(TABLE).bcp.sort
	$(MOVE) $(SOURCE)/$(TABLE).bcp.sort >$(SOURCE)/$(TABLE).bcp
	$(DEL) $(SOURCE)/$(TABLE).bcp.sort
	sort $(TARGET)/$(TABLE).bcp >$(TARGET)/$(TABLE).bcp.sort
	$(MOVE) $(TARGET)/$(TABLE).bcp.sort >$(TARGET)/$(TABLE).bcp
	$(DEL) $(TARGET)/$(TABLE).bcp.sort

#
#   END
#
