#!perl -w

use strict;
use Test::More tests => 2;
use DE_EPAGES::Core::API::Script qw( RunScript );
use DE_EPAGES::Core::API::File qw( CopyFile CompareMD5File GetFileMD5Digest );
use DE_EPAGES::XML::API::XML::CartridgeInstallerImportHandler qw(UpdateCartridgesXml);

sub Main {

    my $CartridgesXml = $ENV{EPAGES_CARTRIDGES}. '/Cartridges.xml';
    my ($ExpectedFile, $Result);

    CopyFile($CartridgesXml, "$CartridgesXml.~$$~");

    CopyFile('conf/Cartridges.xml', $CartridgesXml);
    UpdateCartridgesXml();
    $ExpectedFile = 'conf/Cartridges.xml.sorted';
    $Result = CompareMD5File($ExpectedFile, GetFileMD5Digest($CartridgesXml));
    ok( $Result, "CompareMD5File($ExpectedFile, GetFileMD5Digest($CartridgesXml))");

    CopyFile('conf/Cartridges.xml', $CartridgesXml);
    UpdateCartridgesXml(undef, 'conf/patch.conf');
    $ExpectedFile = 'conf/Cartridges.xml.patched';
    $Result = CompareMD5File($ExpectedFile, GetFileMD5Digest($CartridgesXml));
    ok( $Result, "CompareMD5File($ExpectedFile, GetFileMD5Digest($CartridgesXml))");

    CopyFile("$CartridgesXml.~$$~", $CartridgesXml);
}

RunScript(Sub=>\&Main, Debug=>1);
